/* Jeu de Dé électronique
   Cette application va vous permettre de réaliser un Dé électronique
   à affichage aléatoire (piloté par un bouton-poussoir).
     
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

byte Face;                                   // Variable mémorisant la face du Dé
const byte Bouton = 2;                       // Association du bouton-poussoir au port 2
const byte De[6][7] =                        // Configuration des 7 leds à allumer pour les 6 valeurs du Dé
{
  {0,0,0,0,0,0,1},                           // Dé = 1
  {0,0,1,0,0,1,0},                           // Dé = 2
  {0,0,1,0,0,1,1},                           // Dé = 3
  {1,0,1,1,0,1,0},                           // Dé = 4
  {1,0,1,1,0,1,1},                           // Dé = 5
  {1,1,1,1,1,1,0}                            // Dé = 6
};
  
void setup() 
{  
  for (byte i = 7 ; i < 14; i++)             // Initialisation des ports 7 à 13 de la platine "Flip & Click" en sortie
  {
  pinMode(i, OUTPUT);                        // Attribution des ports en sortie
  digitalWrite(i, LOW);                      // Eteint toutes les leds du Dé
  }
  pinMode(Bouton, INPUT);                    // Le port relié au bouton est configuré en entrée
  randomSeed(analogRead(0));                 // Réinitialise la séquence aléatoire
}

void loop() {
  if (digitalRead(Bouton) == LOW) {          // Test la sollicitation du bouton-poussoir
    for (byte i = 1 ; i < 11; i++)           // Le Dé roule 10 fois (en affichant ses faces)
    {
      Face = random(0,6);                    // Choisi un nombre aléatoire compris entre 0 et 5 pour définir la face du Dé (1 à 6)
      for(byte j = 7; j < 14 ; j++)          // Affichage des Leds de la face du Dé sélectionnée
      {
        digitalWrite(j, De[Face][j-7]);      // Récupère les leds à afficher par rapport au coup de Dé aléatoire
      }
     delay(150);                             // Temporisation entre l'affichage des faces du Dé
    }  
  }
}
