/* Thermostat à Leds
   Cette application va vous permettre de réaliser un petit thermostat
   dont les 3 états sont visualisés par 3 leds différentes.
 
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
   
*/

byte Temperature;                         // Variable pour la mesure de la température 
byte Consigne;                            // Variable dans laquelle on mémorise la valeur de consigne
byte Etat;                                // Variable dans laquelle on mémorise l'état du thermostat
const byte LM35 = A5;                     // Attribution de la sortie du LM35 au port A5
const byte LedR = 10;                      // Attribution du port 10 à la led rouge
const byte LedV = 9;                      // Attribution du port 9 à la led verte
const byte LedO = 8;                      // Attribution du port 8 à la led orange
const byte BP = 2;                        // Attribution du port 2 au bouton-poussoir 

void setup() 
{  
  for (byte i = 8 ; i < 11; i++)           // Initialisation des ports 8 à 10 de la platine "Flip & Click" en sortie
  {
  pinMode(i, OUTPUT);                     // Attribution des ports en sortie
  digitalWrite(i, LOW);                   // Eteint la led 
  }
  pinMode(BP, INPUT);                     // Configure le port sur lequel est relié le bouton-poussoir en entrée
  Consigne = analogRead(LM35);            // Mémorise la valeur de consigne 
}

void loop()
{
   if (digitalRead(BP) == LOW)  Consigne = analogRead(LM35);   // Mémorise valeur de consigne si on sollicite le bouton-poussoir
   Temperature = analogRead(LM35);       // Mesure la tension à la sortie du LM35
 
    if (abs(Consigne- Temperature) <= 3 ) Etat = 0; 

    if (Consigne > Temperature) 
       { if ((Consigne-Temperature) > 3 ) Etat = 1;}
    else
       { if ((Temperature-Consigne) > 3 ) Etat = 2;}

   switch (Etat) {                       // Allume les leds du thermostat en fonction du respect de la valeur de consigne
    case 1:                              // La température est en dessous de la valeur de consigne 
         digitalWrite(LedR, LOW);        // Eteint toutes les leds sauf la led orange
         digitalWrite(LedV, LOW);       
         digitalWrite(LedO, HIGH);                
      break;
    case 2:                              // La température est au dessus de la valeur de consigne
         digitalWrite(LedR, HIGH);       // Eteint toutes les leds sauf la led rouge
         digitalWrite(LedV, LOW);       
         digitalWrite(LedO, LOW);  

      break;
    default:                             // On est forcément dans le cas où la valeur de consigne est respectée 
         digitalWrite(LedR, LOW);        // Eteint toutes les leds sauf la led verte
         digitalWrite(LedV, HIGH);       
         digitalWrite(LedO, LOW);       
    break;
  }
  delay(10);
}
