/* Mini centrale de mesure
   Cette application va vous permettre de réaliser une mini centrale de mesure
   pour votre ordinateur, laquelle pourra (via des ordres envoyés depuis le clavier de votre ordinateur)
   demander à la platine "Flip & Click" de lui retourner des informations
   diverses sur des capteurs ou encore de piloter l'état une led 
   
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

const byte Led = 10;                                            // Association de la Led au port 10
const byte BP = 11;                                             // Association du bouton-poussoir au port 11
const byte LDR = A4;                                            // N° du port sur lequel est relié la LDR
const byte Rajustable = A5;                                     // N° du port sur lequel est relié la résistance ajustable
const byte LM35 = A3;                                           // N° du port sur lequel est relié le capteur LM35
byte k;                                                         // Variable utilisée pour la réception des ordres de votre ordinateur
int Temperature;                                                // Variable pour la mesure de la température 
char recu[3];                                                   // Buffer de réception des ordres séries issus de votre ordinateur
 
void setup() 
{  
  Serial.begin(9600);                                           // Initialisation du port série
  pinMode(Led, OUTPUT);                                         // Le port de la led est en sortie
  digitalWrite(Led, LOW);                                       // Eteint led 
  pinMode(BP, INPUT);                                           // Le port du bouton-poussoir est en entrée
}

void loop() 
   {
   k = 0 ;                                                      // Initialisation des variables
   recu[0] = 0;  
   float millivolt = (analogRead(LM35)/1023.0)*3200;            // Mesure et conversion de la tension en température
   float celcius = millivolt/10;
   
   while (Serial.available() > 0)                               // Attente et récupération des ordres séries de votre ordinateur
   {
      recu[k] = Serial.read(); 
      k++;   
      delay(10); 
   }  


//--------------------
 
   switch (recu[0]) {                                           // Regarde quel ordre a été reçu ?
    case 65:                                                    // Code ASCII reçu = 65 (lette A) -> Allume la Led 
         digitalWrite(Led, HIGH);                               // Allume la led              
      break;

//--------------------
      
    case 66:                                                    // Code ASCII reçu = 66 (lette B) -> Demande l'état du bouton 
         if (digitalRead(BP) == LOW)                            // Envoi l'état du bouton-poussoir 
         {Serial.println("Le bouton-poussoir est sollicite");}
         else
         {Serial.println("Le bouton-poussoir n'est pas utilise");}    
      break;  
      
//--------------------
          
    case 69:                                                    // Code ASCII reçu = 69 (lette E) -> Eteint la Led 
         digitalWrite(Led, LOW);                                // Eteint la led              
      break;
      
//--------------------

    case 76:                                                    // Code ASCII reçu = 76 (lette L) -> Mesure de la LDR 
         Serial.print("Valeur retournee par la LDR: ");         // Envoi la valeur mesurée pour la LDR 
         Serial.println(analogRead(LDR));               
      break;      
      
//--------------------
         
     case 82:                                                    // Code ASCII reçu = 82 (lette R) -> Mesure de la résistance ajustable 
         Serial.print("Valeur retournee par la resistance ajustable: ");    // Envoi la valeur mesurée au curseur de la résistacne ajustable 
         Serial.print(analogRead(Rajustable));     
         Serial.print(" -> soit: ");
         Serial.print((analogRead(Rajustable)*3.3)/1023); 
         Serial.println(" Vcc"); 
      break;   
  
//--------------------

     case 84:                                                    // Code ASCII reçu = 84 (lette T) -> Mesure de la température
         Serial.print("Valeur de la temperature: ");             // Renvoie la valeur mesurée par le capteur LM35D    
         Serial.print(celcius);
         Serial.println(" C"); 
      break;
       
//--------------------

    default:                                                   // Ordre non reconnu
         if (k != 0) Serial.println("Ordre non reconnu !");    // On le signal à votre ordinateur  
    break;
  }
}
 

