/* Utilisation du module MIKROE-1993
   Cette application va vous permettre de réaliser un mini jeu de tennis (2 joueurs) à l'aide
   de la matrice du module "7x10 R Click" (à mettre sur le support A de la platine "Flip & Click").
       
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                                      // Intégration de la librairie SPI
#define CS0 77                                        // Attribution du signal CS0 au port 77
#define RCLK 54                                       // Attribution du signal RCLK au port 54
#define MR 33                                         // Attribution du signal MR au port 33
#define RST 6                                         // Attribution du signal RST au port 6
#define Rajustable 55                                 // N° du port sur lequel est relié la résistance ajustable 1
#define Rajustable2 56                                // N° du port sur lequel est relié la résistance ajustable 2
                            
const byte MScore[6][7] ={{0b00000000,0b00001110,0b00001010,0b00001010,0b00001010,0b000001110,0b00000000},    // Zéro
                          {0b00000000,0b00000100,0b00000110,0b00000100,0b00000100,0b000001110,0b00000000},    // Un
                          {0b00000000,0b00001110,0b00001000,0b00001110,0b00000010,0b000001110,0b00000000},    // Deux
                          {0b00000000,0b00001110,0b00001000,0b00001100,0b00001000,0b000001110,0b00000000},    // Trois
                          {0b00000000,0b00001010,0b00001010,0b00001110,0b00001000,0b000001000,0b00000000},    // Quatre
                          {0b00000000,0b00001110,0b00000010,0b00001110,0b00001000,0b000001110,0b00000000}};   // Cinq
                           
byte Decompte,Vitesse=20,Niveau=25;                   // Vitesse de déplacement de la balle 
byte Matrice[2][7];                                   // Définition de la matrice (aire de jeu)
byte PosRaquette;                                     // Définition de la position initiale de la raquette 1 
byte PosRaquette2;                                    // Définition de la position initiale de la raquette 2
byte MBall, xBall, yBall, DxBall, DyBall;             // Variables pour la gestion de la balle
byte ScoreJ1=0,ScoreJ2=0;                             // Score Joueur 1 et Joueur 2
                              
void setup() {
  randomSeed(analogRead(57));                         // Réinitialise la séquence aléatoire
  pinMode(CS0, OUTPUT);pinMode(RCLK, OUTPUT);         // Les broches CS0 et RCLK sont des sorties
  pinMode(MR, OUTPUT);pinMode(RST, OUTPUT);           // Les broches MR et RST sont des sorties
  digitalWrite(MR, HIGH);                             // Force la broche MR au niveau logique haut
  digitalWrite(RCLK, LOW);                            // Niveau logique bas sur l'horloge du 4017 du module 7x10 R click
  digitalWrite(RST, LOW);                             // Niveau logique bas sur l'entrée de RESET du 4017 du module 7x10 R click
  SPI.begin();                                        // Initialiation du port SPI
  AffScore();                                         // Affiche le score
  Decompte=Vitesse;                                   // Initialise la vitesse de déplacement de la balle
  MisEnJeu();}

void loop() {        
   //---------------------------------- Gestion du déplacement de la raquette 1 -----------------------------
   
   PosRaquette = analogRead(Rajustable)/100;
   if (PosRaquette < 1) PosRaquette=1; if (PosRaquette > 6) PosRaquette=6;                                        // Limite le déplacement de la raquette
   bitSet(Matrice[0][PosRaquette],4);bitSet(Matrice[0][PosRaquette-1],4);                                         // Configure les bits de la raquette à "1"
   if(PosRaquette!=6) bitClear(Matrice[0][PosRaquette+1],4);
   if(PosRaquette!=1) bitClear(Matrice[0][PosRaquette-2],4);                                                      // Configure les bits autour de la raquette à "0"

   //---------------------------------- Gestion du déplacement de la raquette 2 -----------------------------
   
   PosRaquette2 = analogRead(Rajustable2)/100;
   if (PosRaquette2 < 1) PosRaquette2=1; if (PosRaquette2 > 6) PosRaquette2=6;                                    // Limite le déplacement de la raquette
   bitSet(Matrice[1][PosRaquette2],0);bitSet(Matrice[1][PosRaquette2-1],0);                                       // Configure les bits de la raquette à "1"
   if(PosRaquette2!=6) bitClear(Matrice[1][PosRaquette2+1],0);
   if(PosRaquette2!=1) bitClear(Matrice[1][(PosRaquette2)-2],0);                                                  // Configure les bits autour de la raquette à "0"
    
   //---------------------------------- Gestion du déplacement de la balle -----------------------------

   Decompte--;                                                      // Décompte temporisation pour déterminer la vitesse de déplacement de la balle 
   if (Decompte == 0)                                               // Regarde si on déplace la balle
     {Decompte=Vitesse; bitClear(Matrice[MBall][xBall],yBall);      // Réinitialise le compteur et efface l'ancienne position de la balle
     if (DxBall==1)                                                 // Test collision balle les murs de droite et gauche 
       {xBall--;if(xBall==255){xBall=1;DxBall=0;}}                  // Collision mur de droite -> Inverse sens de déplacement
     else
       {xBall++;if(xBall==7)  {xBall=5;DxBall=1;}}                  // Collision mur de droite -> Inverse sens de déplacement    
     if (DyBall==1)                                                 // Test collision balle avec raquette 2 et déplacement entre les matrices 
       {yBall--; if (yBall==255 & MBall==0) {MBall=1;yBall=4;}      // Test passage matrice base vers matrice haut
       
       if (yBall==0 & MBall==1 & bitRead(Matrice[1][xBall],0)==1)   // Test rebond avec la raquette joueur 2
         {Vitesse--;if (Vitesse<5) Vitesse=5;yBall=2;DyBall=0;}     // Augmente la vitesse de déplacement de la balle 
       else
       if (yBall==0 & MBall==1 & bitRead(Matrice[1][xBall],0)==0)   // Test balle perdue par joueur 2
          {ScoreJ1++;CligneBall();                                  // Donne le point à l'autre joueur et affiche la score         
          if (ScoreJ1==5)  {CligneScore();} else {MisEnJeu();}}}   
     else
      {yBall++; if (yBall==5 & MBall==1) {MBall=0;yBall=0;}         // Test passage matrice du haut vers matrice du bas             
       if (yBall==4 & MBall==0 & bitRead(Matrice[0][xBall],4)==1)   // Test rebond avec la raquette du joeur N° 1 
         {Vitesse--;if (Vitesse<5) Vitesse=5;DyBall=1;yBall=2;}     // Augmente la vitesse de la balle 
       else
         if (yBall==4 & MBall==0 & bitRead(Matrice[0][xBall],4)==0) // Test balle perdue par joueur 1
          {ScoreJ2++;CligneBall();                                                                               // Donne le point à l'autre joueur et affiche la score         
          if (ScoreJ2==5)  {CligneScore();} else {MisEnJeu();}}}}
   bitSet(Matrice[MBall][xBall],yBall);                                                                          // Memorise nouvelle position de la balle  
   Rmatrice();}                                                                                                  // Rafraichissement de la matrice 

void Rmatrice() {                                                                                                // Fonction permettant de rafraichir la matrice
     digitalWrite(RST, HIGH);digitalWrite(RST, LOW);                                                             // Reset du 4017 du module 7x10 R click
     for (byte i = 0 ; i < 7; i++){                                                                              // Boucle générant 7 coups d'horloge sur le 4017 
     digitalWrite(CS0, LOW);                                                                                     // Sélection broche CSO    
     SPI.transfer(Matrice[0][i]); SPI.transfer(Matrice[1][i]);                                                   // Envoi les données aux matrices
     digitalWrite(CS0, HIGH);delay(3);                                                                           // Dé-sélection de la broche CS0 
     digitalWrite(MR, LOW);digitalWrite(MR, HIGH);                                                               // Vide le registre à décalage des 74HC595          
     digitalWrite(RCLK, HIGH);digitalWrite(RCLK, LOW);}                                                          // Coup d'horloge sur le 4017 du module 7x10 R click
     digitalWrite(CS0, LOW);SPI.transfer(Matrice[0][0]); SPI.transfer(Matrice[1][0]);digitalWrite(CS0, HIGH);}

void MisEnJeu() {MBall=random(0,2);                                                                              // Mise en jeu aléatoire de la balle
    if (MBall==0){yBall=0;} else {yBall=4;}                                                                      // Positionnement et direction aléatoire de la balle
    xBall=random(0,7);DxBall=random(0,2);DyBall=random(0,2);bitSet(Matrice[MBall][xBall],yBall);}               

void CligneBall() {Vitesse=Niveau;Decompte=Vitesse;                                                              // Clignotement de la balle perdue
     for (byte i = 0 ; i < 5; i++){ 
     bitSet(Matrice[MBall][xBall],yBall);for (byte i = 0 ; i < 9; i++){Rmatrice();}                              // Memorise nouvelle position de la balle  
     bitClear(Matrice[MBall][xBall],yBall);for (byte i = 0 ; i < 9; i++){Rmatrice();}};delay(500);AffScore();}   // Efface la balle et affiche le score  

void AffScore() {                                                                                                // Fonction pour afficher le score
     for (byte i = 0 ; i < 7; i++){Matrice[0][i]=MScore[ScoreJ1][i];Matrice[1][i]=MScore[ScoreJ2][i];}           // Transfert de matrice pour affichage des scores
     for (byte i = 0 ; i < 70; i++){Rmatrice();}                                                                 // Affiche le score un instant
     for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=0;Matrice[1][i]=0;}}                                           // Efface toutes les leds de la matrice
     
void CligneScore() {while(1){                                                                                    // Fonction pour faire clignoter le score
     for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=MScore[ScoreJ1][i];Matrice[1][i]=MScore[ScoreJ2][i];}          // Transfert de matrice pour affichage des scores
     for (byte i = 0 ; i < 30; i++){Rmatrice();} for (byte i = 0 ; i < 7; i++) {Matrice[0][i]=0;Matrice[1][i]=0;}// Affiche le score un instant
     for (byte i = 0 ; i < 30; i++){Rmatrice();}}}                                                               // Affiche ecran vide un instant

     
