/* Utilisation du module MIKROE-1201
   Cette application va vous permettre de réaliser un compteur sur 2 afficheurs 7 segments
   à l'aide du module "7seg Click" (à mettre sur le support A de la platine "Flip & Click").
  
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

#include <SPI.h>                      // Intégration de la librairie SPI
#define CS0 77                        // Attribution dusignal CS0 au port 77
byte Digit1=0, Digit2=0;              // Variables compteur des 2 digits
const byte Digit[10] ={0b01111110,0b00001010,0b10110110,0b10011110,0b11001010,0b11011100,0b11111100,0b00001110,0b11111110,0b11011110};

void setup() {
  pinMode(CS0, OUTPUT);               // La broche CS0 est une sortie
  SPI.begin();                        // Initialiation du port SPI
}

void loop() {
   digitalWrite(CS0, LOW);            // Sélection broche CSO 
   SPI.transfer(Digit[Digit2]);       // Envoie les données du 2ème digit
   SPI.transfer(Digit[Digit1]);       // Envoie les données du 1er digit  
   digitalWrite(CS0, HIGH);           // Désélectionn la broche CS0 
   Digit2++;                          // Incrémente le compteur (sur digit 2)
   if (Digit2==10){                   // Regarde si unité > 9 ?
     Digit2 = 0;                      // Remet les unités à zéro 
     Digit1++;                        // Incrémente les dizaines 
     if (Digit1==10) Digit1=0; }      // Regarde si dizaine > 9 -> Dizaine = 0
   delay(1000);                       // Temporisation 1 seconde
}
