/* Utilisation du module MIKROE-1834
   Cette application va vous permettre de visualiser l'orientation de la platine "Flip & Click"
   (penchée à droite ou à gauche ou en avant ou en arrière à l'aide des leds A/B/C/D)
   via le module "Tilt Click" (à mettre sur le support A de la platine "Flip & Click").
 
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

const byte Vout1 = 6;                         // Attribution de la sortie Vout1 du module Click au port 6
const byte Vout2 = 26;                        // Attribution de la sortie Vout2 du module Click au port 26

const byte Sled[4] = {38,39,40,37};           // Attribution des N° des ports affectés aux leds A/B/C/D
byte Orientation;                             // Variable dans laquelle est mémorisée l'orientation 
const byte Led[4][4]= {{0,0,1,0},{0,1,0,0},{1,0,0,0},{0,0,0,1}};  // Attribution des leds en fonction de l'orientation

void setup(){  
  pinMode(Vout1, INPUT);                      // Configure le port sur lequel est relié la sortie Vout1 en entrée
  pinMode(Vout2, INPUT);                      // Configure le port sur lequel est relié la sortie Vout2 en entrée
  for (byte i = 0 ; i < 4; i++)               // Initialisation des ports des leds A/B/C/D de la platine "Flip & Click" en sortie
  {pinMode(Sled[i],OUTPUT);                   // Attribution des ports en sortie
  digitalWrite(i, LOW);}}                     // Eteint toutes les leds

void loop(){
  bitWrite(Orientation,0,digitalRead(Vout1)); // Met à jour le bit 0 de la variable Orientation en fonction de Vout1
  bitWrite(Orientation,1,digitalRead(Vout2)); // Met à jour le bit 1 de la variable Orientation en fonction de Vout2
  for (byte i = 0 ; i < 4; i++)               // Initialisation des ports des leds A/B/C/D de la platine "Flip & Click" en sortie
    {digitalWrite(Sled[i],Led[Orientation][i]);}
  delay(100);}                               


     
