/* Utilisation du module MIKROE-1906
   Cette application va vous permettre de réaliser une serrure codée sensitive à 4 touches
   à l'aide du module "TouchKey Click" (à mettre sur le support A de la platine "Flip & Click").
  
   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

const byte BPA = 33;                          // Attribution du bouton-poussoir A au port 33
const byte BPB = A0;                          // Attribution du bouton-poussoir B au port A0
const byte BPC = 6;                           // Attribution du bouton-poussoir C au port 6
const byte BPD = 26;                          // Attribution du bouton-poussoir D au port 26
const byte LedA = 38;                         // Attribution de la led A au port 38
const byte LedB = 37;                         // Attribution de la led B au port 37
byte Etat = 0;                                // Variable état de la sortie de la serrure 
byte Progression = 0;                         // Variable gérant la progression de la saisie du code
byte Touche;                                  // Variable permettant de savoir quelle touche à été sollicitée   
const byte code[4] = {3,2,4,1};               // Séquence du code attendue ( 1=A / 2=B / 3=C / 4=D )
 
void setup(){  
  pinMode(BPA, INPUT);                        // Configure le port sur lequel est relié le bouton-Poussoir A en entrée
  pinMode(BPB, INPUT);                        // Configure le port sur lequel est relié le bouton-Poussoir B en entrée
  pinMode(BPC, INPUT);                        // Configure le port sur lequel est relié le bouton-Poussoir C en entrée
  pinMode(BPD, INPUT);                        // Configure le port sur lequel est relié le bouton-Poussoir D en entrée
  pinMode(LedA, OUTPUT);                      // Configure le port sur lequel est relié la led A en sortie
  digitalWrite(LedA, Etat);                   // Eteint la led A 
  pinMode(LedB, OUTPUT);                      // Configure le port sur lequel est relié la led B en sortie
  digitalWrite(LedB, LOW);}                   // Eteint la led B 

void loop(){
if (digitalRead(BPA)==HIGH|digitalRead(BPB)==HIGH|digitalRead(BPC)==HIGH|digitalRead(BPD)==HIGH){     // Regarde si une des 4 touche est sollicitée
   Relache();                                 // Attend relachement de toutes les touches 
   if (code[Progression]==Touche)             // La touche socciliée est elle celle attendue
      {Progression++;}                        // Oui alors on avance dans la progression du code
   else
      {Progression=0;}                        // Non alors on repart du début dans la progression des touches attendues                    
   if (Progression==4){
       Etat = !Etat;                          // Inverse l'état de la variable Etat
       digitalWrite(LedA, Etat);              // Met à jour l'état de la led A   
       Progression=0;}}}                      // On repart du début dans la progression du code
 
    void Relache(){ 
    digitalWrite(LedB, HIGH);                 // Allume la led B
    delay (20);                               // Tempo anti-rebond
    if (digitalRead(BPA)==HIGH) Touche=1;     // Regarde si c'est la touche A qui est sollicitée ?
    if (digitalRead(BPB)==HIGH) Touche=2;     // Regarde si c'est la touche B qui est sollicitée ?
    if (digitalRead(BPC)==HIGH) Touche=3;     // Regarde si c'est la touche C qui est sollicitée ?
    if (digitalRead(BPD)==HIGH) Touche=4;     // Regarde si c'est la touche D qui est sollicitée ?
    while (digitalRead(BPA)==HIGH|digitalRead(BPB)==HIGH|    // Attend le relachement de toutes les touches
     digitalRead(BPC)==HIGH|digitalRead(BPD)==HIGH){}
     digitalWrite(LedB, LOW);                 // Eteint la led B
     delay (20);}                             // Tempo anti-rebond 

     
