/* Utilisation du module MIKROE-1890
   Cette application va vous permettre de convertir la lumière ambiante en une tension
   à l'aide du module "Ambient Click" (à mettre sur le support A de la platine "Flip & Click").
   Le niveau de lumière capté servira à régler la luminosié de la led B 

   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/

const byte Led = 13;                         // Attribution de la led B au port N° 13
int MIKROE1890 = A0;                         // N° du port sur lequel est relié le capteur de luminosité
int Rcycle = 0;                              // Variable dédiée au stockage du paramètre du rapport cyclique
 
void setup() 
{  
  Serial.begin(9600);                        // initialise le port de communication série à 9600 bds
  pinMode(Led, OUTPUT);                      // Configure le port sur lequel est relié la led B en sortie
}

void loop()
{
  Rcycle = analogRead(MIKROE1890);           // Lecture de la tension présente en sortie du capteur
  Serial.println(Rcycle);                    // Envoi la valeur mesurée sur le terminal série (via le port série)
  delay (10);                                // Temporisation 
  analogWrite(Led, (1023-Rcycle)/4);         // Générère signal le PWM sur la led 13   
}
