/* Utilisation du module MIKROE-1901
   Cette application va vous permettre d'apprendre à utiliser une interruption
   à l'aide du module "Button R Click" (à mettre sur le support A de la platine "Flip & Click").

   CE PROGRAMME EST FOURNI «TEL QUEL», SANS GARANTIE D'AUCUNE SORTE, EXPLICITE OU
   IMPLICITE, Y COMPRIS MAIS SANS S'Y LIMITER LES GARANTIES DE QUALITÉ MARCHANDE,
   D'ADAPTATION À UN USAGE PARTICULIER ET D'ABSENCE DE CONTREFAÇON. EN AUCUN CAS, LA
   RESPONSABILITE DES AUTEURS OU DES DÉTENTEURS DE DROITS D'AUTEUR NE SERONT TENUS 
   RESPONSABLES DE TOUTE RECLAMATION, DOMMAGE OU AUTRE RESPONSABILITÉ, QUE CE SOIT
   DANS UNE ACTION DE CONTRAT, TORT OU AUTREMENT, PROVENANT DE, OU EN RELATION AVEC
   CE PROGRAMME OU L'UTILISATION OU AUTRES TRAITEMENTS DU PROGRAMME.
    
*/
 
const byte LedBP = 6;                       // Association de la Led du bouton-poussoir du module MIKROE-1921 au port 6
const byte BP = 26;                         // Attribution du bouton-poussoir du module MIKROE-1921 au port 26
volatile byte Etat = 0;                     // Défininit l'état initial de la variable Etat
const byte Led[4] = {38,37,39,40};          // Affectation d'une variable pour gérer l'ordre d'affichage des Leds 
byte j = 0;                                 // Variable utilisée pour le defilement des leds A / B / C / D
void setup() 
{

  for (byte i = 37 ; i < 41; i++)           // Initialisation des ports 37 à 40 de la platine "Flip & Click" en sortie
  {
  pinMode(i, OUTPUT);                       // Attribution des ports en sortie
  digitalWrite(i, HIGH);                    // Eteint les 4 leds A / B / C / D
  }
  
  pinMode(LedBP, OUTPUT);                   // Configure le port sur lequel est relié la led du boouton-poussoir en sortie
  digitalWrite(LedBP, Etat);                // Eteint la led qui est dans le bouton-poussoir
  pinMode(BP, INPUT);                       // Configure l'entrée sur laquelle est relié le bouton-poussoir en entrée
  attachInterrupt(digitalPinToInterrupt(BP), Inverse, RISING);  // Configure l'entrée sur laquelle est reliée le BP en interruptio
}                                                               // réagissant sur un front montant et générantl'appelde la fonction "Inverse"

void loop() 
{
  for (byte i = 0 ; i < 4; i++)             // Affectation de l'ordre des leds à allumer
  {
    if (j == i)                             // Sélectionn les leds à allumer et à éteindre
      {
      digitalWrite(Led[i], HIGH);           // Allume la led
      }
    else  
      {
      digitalWrite(Led[i], LOW);            // Eteint la led
      }         
  }
  digitalWrite(LedBP, Etat);                // Allume ou éteint la led du Bouton-poussoir en fonction de la variable Etat
  j++;                                      // Sélectionne la prochaine led à allumer
  if (j > 3) j=0;                           // Si on est arrivé à la dernière led -> Retourne à la première
  delay(250);                               // Temporisation de 1 seconde
}

void Inverse() {Etat = !Etat; }             // Inverse l'état de la variable Etat


